## gdm3 50~alpha.1

=== meson_options.txt ===
option('at-spi-registryd-dir', type: 'string', value: '', description: 'Specify the directory of at-spi-registryd.')
option('custom-conf', type: 'string', value: '', description: 'Filename to give to custom configuration file.')
option('dbus-sys', type: 'string', value: '', description: 'Where D-Bus systemd directory is.')
option('default-pam-config', type: 'combo', choices: [ 'autodetect', 'redhat', 'openembedded', 'exherbo', 'lfs', 'arch', 'none'], value: 'autodetect', description: '')
option('default-path', type: 'string', value: '/usr/local/bin:/usr/local/sbin:/usr/bin:/usr/sbin:/bin:/sbin', description: 'Path GDM will use as the user\'s default PATH.')
option('defaults-conf', type: 'string', value: '', description: 'Filename to give to defaults file.')
option('distro', type: 'string', value: 'none', description: 'Distribution name, used to detect PAM files and hook scripts.')
option('dmconfdir', type: 'string', value: '', description: 'Directory where sessions are stored.')
option('gdm-xsession', type: 'boolean', value: false, description: 'Enable installing the gdm Xsession file.')
option('group', type: 'string', value: 'gdm', description: 'GDM\'s group.')
option('initial-vt', type: 'integer', value: 1, description: 'Initial virtual terminal to use.')
option('lang-file', type: 'string', value: '', description: 'File containing default language settings.')
option('libaudit', type: 'feature', value: 'auto', description: 'Add Linux audit support.')
option('logind-provider', type: 'combo', choices: ['systemd', 'elogind'], value: 'systemd', description: 'Which logind library to use.')
option('log-dir', type: 'string', value: '/var/log/gdm', description: 'Log directory.')
option('pam-mod-dir', type: 'string', value: '', description: 'Directory to install PAM modules in.')
option('pam-prefix', type: 'string', value: '', description: 'Specify where PAM files go.')
option('pid-file', type: 'string', value: '', description: 'Pid file.')
option('plymouth', type: 'feature', value: 'auto', description: 'Add plymouth support.')
option('private-dbus-dir', type: 'string', value: '', description: 'Directory for private D-Bus server sockets')
option('profiling', type: 'boolean', value: false, description: 'Enable profiling.')
option('run-dir', type: 'string', value: '', description: 'Runtime directory.')
option('runtime-conf', type: 'string', value: '', description: 'Filename to give to runtime configuration file.')
option('selinux', type: 'feature', value: 'auto', description: 'Add SELinux support.')
option('solaris', type: 'boolean', value: false, description: 'Build for Solaris')
option('split-authentication', type: 'boolean', value: true, description: 'Enable multiple simultaneous PAM conversations during login.')
option('sysconfsubdir', type: 'string', value: 'gdm', description: 'Directory name used under sysconfdir.')
option('systemd-journal', type: 'boolean', value: true, description: 'Use journald support.')
option('systemdsystemunitdir', type: 'string', value: '', description: 'Directory for systemd service files, or \'no\' to disable.')
option('systemduserunitdir', type: 'string', value: '', description: 'Directory for systemd user service files, or \'no\' to disable.')
option('x11-support', type: 'boolean', value: true, description: 'Enable support for x11 sessions.')
option('working-dir', type: 'string', value: '', description: 'Working directory.')
option('dyn-home-dir', type: 'string', value: '', description: 'Parent directory for dynamic user home directories')

=== debian/changelog ===
gdm3 (50~alpha.1-0ubuntu1) resolute; urgency=medium

  * Merge with debian. Remaining changes:
    + readme.debian: update for correct paths in ubuntu
    + control:
      - don't recommend desktop-base
      - depend on bash for config_error_dialog.patch
      - update vcs field
    + rules:
      - don't override default user/group
      - override dh_installinit with --no-start to avoid session being killed
    + rules, readme.debian, gdm3.8.pod:
      use upstream custom.conf instead of daemon.conf
    + gdm3.sysusers: rename user and group back to gdm
    + debian/tests/control:
      - Use gdm user name
    + gdm3.*.pam: make pam_env read ~/.pam_environment, as we use in g-c-c
      settings
    + add revert_override_lang_with_accountservices.patch:
      - on ubuntu accountservices only stores the language and not the
        full locale as needed by lang.
    + add dont_set_language_env.patch:
      - don't run the set_up_session_language() function, since it
        overrides variable values set by ~/.pam_environment
    + add config_error_dialog.patch:
      - show warning dialog in case of error in ~/.profile etc. and
        don't let a syntax error make the login fail
    + add prefer_ubuntu_session_fallback.patch:
      - Prefer ubuntu session as fallback instead of GNOME
    + debian/greeter.dconf-defaults:
      - don't set debian settings in the greeter's dconf db
      - keep smartcard auth enabled by default
    + Add systemd drop-in to skip snapd.session-agent in the greeter session
      (LP #2125133)
  * New upstream release 50.alpha.1
  * d/p/launch-environment: Drop patch applied upstream
  * d/p/u/Never-use-Xorg-for-the-greeter.patch: Drop patch not necessary anymore
  * d/p/16_xserver_path.patch, d/rules: Drop patch not necessary anymore
  * d/p/94_retain_xorg_log.patch: Drop unused patch
  * d/p/u/nvidia_prime.patch: Drop unsupported patch
  * d/p: Rebase all other patches
  * d/rules: Drop unused configuration options
  * d/rules: Stop deleting source files in clean
  * d/install: Cleanup non existing files
  * d/install: Add new installed files
  * d/symbols: Update symbols
  * d/control: Bump minimum gnome-shell and gnome-session

 -- Alessandro Astone <alessandro.astone@canonical.com>  Mon, 12 Jan 2026 10:17:10 +0100

gdm3 (49.2-1ubuntu4) resolute; urgency=medium

  * Fix greeter startup with systemd version mismatch.
    When compiling against the latest libsystemd but then loading an older
    libsystemd at runtime, it will error due to not recognizing a new flag.
    Add d/p/userdb-Temporarily-unset-SD_VARLINK_SERVER_MODE_MKDIR_075.patch
    to address this issue until the newer systemd migrates out of proposed.
    (LP: #2135922)

 -- Alessandro Astone <alessandro.astone@canonical.com>  Mon, 15 Dec 2025 10:08:30 +0100

gdm3 (49.2-1ubuntu3) resolute; urgency=medium

  * Relax versioned dependency on systemd

 -- Alessandro Astone <alessandro.astone@canonical.com>  Fri, 12 Dec 2025 11:39:41 +0100

gdm3 (49.2-1ubuntu2) resolute; urgency=medium

  * Fix wireplumber not remembering the last used configuration (LP: #2131628)

 -- Alessandro Astone <alessandro.astone@canonical.com>  Fri, 05 Dec 2025 16:33:50 +0100

gdm3 (49.2-1ubuntu1) resolute; urgency=medium

  * Merge with debian. Remaining changes:
    + readme.debian: update for correct paths in ubuntu
    + control:
      - don't recommend desktop-base
      - depend on bash for config_error_dialog.patch
      - update vcs field
    + rules:
      - don't override default user/group
      - override dh_installinit with --no-start to avoid session being killed
    + rules, readme.debian, gdm3.8.pod:
      use upstream custom.conf instead of daemon.conf
    + gdm3.sysusers: rename user and group back to gdm
    + debian/tests/control:
      - Use gdm user name
    + gdm3.*.pam: make pam_env read ~/.pam_environment, as we use in g-c-c
      settings
    + add nvidia_prime.patch:
      - add hook to run prime-offload (as root) and prime-switch if
        nvidia-prime is installed
    + add revert_override_lang_with_accountservices.patch:
      - on ubuntu accountservices only stores the language and not the
        full locale as needed by lang.
    + add dont_set_language_env.patch:
      - don't run the set_up_session_language() function, since it
        overrides variable values set by ~/.pam_environment
    + add config_error_dialog.patch:
      - show warning dialog in case of error in ~/.profile etc. and
        don't let a syntax error make the login fail
    + add prefer_ubuntu_session_fallback.patch:
      - Prefer ubuntu session as fallback instead of GNOME
    + debian/greeter.dconf-defaults:
      - don't set debian settings in the greeter's dconf db
      - keep smartcard auth enabled by default
    + Disable x11 greeter
      - add d/p/Never-use-Xorg-for-the-greeter.patch
      - d/control: Drop dependency on Xorg
    + Add systemd drop-in to skip snapd.session-agent in the greeter session
      (LP #2125133)
    + d/control: Drop unused dependency on dbus-daemon

 -- Alessandro Astone <alessandro.astone@canonical.com>  Tue, 25 Nov 2025 11:27:15 +0100

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk
include /usr/share/gnome-pkg-tools/1/rules/gnome-version.mk

built_binaries := $(shell dh_listpackages)

export systemdsystemunitdir = $(shell pkgconf --variable=systemdsystemunitdir systemd | sed s,^/,,)
export udevdir = $(shell pkgconf --variable=udevdir udev | sed s,^/,,)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,defs
export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

# https://bugs.debian.org/1060838, https://bugs.debian.org/1111001
export MESON_USE_NEW_CROSSGEN=1

ifeq (linux,$(DEB_HOST_ARCH_OS))
CONFFLAGS += \
	-Dselinux=enabled \
	-Dplymouth=enabled
else
CONFFLAGS += \
	-Dwayland-support=false \
	-Dselinux=disabled
endif

pod2man := pod2man --release="GNOME $(DEB_GNOME_VERSION)" --center="Debian GNU/Linux"
PODFILES := $(wildcard debian/*.pod)
MANPAGES := $(patsubst %.pod,%,$(PODFILES))

debian/%: debian/%.pod
	$(pod2man) --section=$(shell echo $@ | sed 's/.*\.//') \
		$< | sed -e 's/debian:://' >$@

%:
	dh $@

# We set this up manually
override_dh_installsystemd:

override_dh_auto_configure:
	dh_auto_configure -- \
		-Ddistro=debian \
		-Dat-spi-registryd-dir=/usr/lib/at-spi \
		-Ddefault-path=/usr/local/bin:/usr/bin:/bin:/usr/games \
		-Dsysconfsubdir=gdm3 \
		-Dworking-dir=/var/lib/gdm3 \
		-Drun-dir=/run/gdm3 \
		-Dpid-file=/run/gdm3.pid \
		-Dlog-dir=/var/log/gdm3 \
		-Dpam-mod-dir=/usr/lib/$(DEB_HOST_MULTIARCH)/security \
		-Ddefaults-conf=/usr/share/gdm/defaults.conf \
		-Dgdm-xsession=true \
		-Dlang-file=/etc/default/locale \
		-Dx11-support=true \
		$(CONFFLAGS)

override_dh_auto_build: $(OUTFILES) $(MANPAGES)
	dh_auto_build

execute_after_dh_install:
ifneq ($(filter gdm3,$(built_binaries)),)
	mv debian/gdm3/usr/sbin/gdm debian/gdm3/usr/sbin/gdm3
	chmod 755 debian/gdm3/usr/share/gdm/generate-config
	dh_installpam -pgdm3 --name=gdm-autologin
	dh_installpam -pgdm3 --name=gdm-launch-environment
	dh_installpam -pgdm3 --name=gdm-password
	dh_installpam -pgdm3 --name=gdm-fingerprint
	dh_installpam -pgdm3 --name=gdm-smartcard-sssd-exclusive
	dh_installpam -pgdm3 --name=gdm-smartcard-sssd-or-password
	dh_installpam -pgdm3 --name=gdm-smartcard-pkcs11-exclusive
endif

override_dh_installinit:
	dh_installinit --noscripts --no-start

execute_after_dh_auto_clean:
	rm -f $(MANPAGES)
	rm -f $(OUTFILES)

=== debian/tests/control ===
Test-Command: sudo env
  OFFLINE_MODE=1
  GDM_USER=gdm
  bash debian/tests/sssd-gdm-smartcard-pam-auth-tester.sh
Features: test-name=sssd-gdm-smartcard-auth-test
Classes: desktop
Architecture: !armel
Depends: bash,
         gdm3,
         gnutls-bin,
         libpam-sss,
         openssl,
         pamtester,
         passwd,
         softhsm2,
         sssd,
         util-linux
Restrictions: breaks-testbed,
              isolation-container,
              needs-sudo,
              allow-stderr

Tests: greeter
Depends: gdm3,
         dpkg-dev,
         python3,
         python3-gi,
         gir1.2-glib-2.0,
Restrictions: breaks-testbed,
              isolation-machine,
              needs-root,

## gdm3 50~beta

=== debian/changelog ===
gdm3 (50~beta-0ubuntu3) resolute; urgency=medium

  * d/p: Enable GPU rendering in GNOME Remote Desktop session (LP: #2077538)
  * d/p: Drop patch for systemd mismatch
  * d/control: Depend on libsystemd >= 259

 -- Alessandro Astone <alessandro.astone@canonical.com>  Wed, 18 Feb 2026 16:28:20 +0100

gdm3 (50~beta-0ubuntu2) resolute; urgency=medium

  [ Jonas Jelten ]
  * d/t/sssd-gdm-smartcard-pam-auth-tester: remove sssd implicit files domain
    (Closes: #1126368) (LP: #2130705)

 -- Alessandro Astone <alessandro.astone@canonical.com>  Tue, 17 Feb 2026 11:56:35 +0100

gdm3 (50~beta-0ubuntu1) resolute; urgency=medium

  * New upstream release:
    - libgdm/client: Track proxies connection state and do not return invalid
      ones (LP: #2125720)
    - Fix GNOME login screen stops responding (LP: #2125720)
    - Fix PAM Worker crash breaks further logins (LP: #2117248)
  * debian/rules: Remove unused udevdir variable
  * d/p: Refresh git indexes
  * debian/libgdm1.symbols: Add new symbols

 -- Marco Trevisan (Treviño) <marco@ubuntu.com>  Tue, 17 Feb 2026 00:07:21 +0100

gdm3 (50~alpha.1-0ubuntu2) resolute; urgency=medium

  * d/tests: Skip greeter test if no primary GPU is detected

 -- Alessandro Astone <alessandro.astone@canonical.com>  Mon, 16 Feb 2026 12:50:59 +0100

=== debian/control ===
Source: gdm3
Section: gnome
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
Uploaders: Jeremy Bicha <jbicha@ubuntu.com>, Marco Trevisan (Treviño) <marco@ubuntu.com>
Build-Depends: check (>= 0.9.4),
               dconf-cli (>= 0.19.90),
               debhelper-compat (= 13),
               dh-exec,
               dh-sequence-gir,
               dh-sequence-gnome,
               dh-sequence-installsysusers,
               docbook-xml,
               gettext (>= 0.19.8),
               gir1.2-gio-2.0-dev,
               gir1.2-glib-2.0-dev,
               gir1.2-gobject-2.0-dev,
               gjs [amd64 arm64 armhf i386 loong64 ppc64el riscv64 s390x],
               gnome-settings-daemon-dev (>= 3.24.0),
               gobject-introspection (>= 1.80),
               intltool,
               iso-codes,
               itstool,
               libaccountsservice-dev (>= 0.6.35),
               libaudit-dev [linux-any],
               libglib2.0-dev (>= 2.44.0),
               libgtk-3-dev (>= 2.91.1),
               libgudev-1.0-dev (>= 232),
               libjson-glib-dev,
               libkeyutils-dev [linux-any],
               libpam0g-dev,
               libplymouth-dev [linux-any],
               libselinux1-dev [linux-any],
               libsystemd-dev (>= 259) [linux-any],
               libwrap0-dev,
               libx11-dev,
               libxau-dev,
               libxcb1-dev,
               libxdmcp-dev,
               meson (>= 0.57),
               pkgconf,
               systemd-dev,
Standards-Version: 4.7.3
XS-Debian-Vcs-Git: https://salsa.debian.org/gnome-team/gdm.git
XS-Debian-Vcs-Browser: https://salsa.debian.org/gnome-team/gdm
Vcs-Git: https://salsa.debian.org/gnome-team/gdm.git -b ubuntu/latest
Vcs-Browser: https://salsa.debian.org/gnome-team/gdm/tree/ubuntu/latest
Homepage: https://wiki.gnome.org/Projects/GDM/

Package: gdm3
Architecture: amd64 arm64 armhf i386 loong64 ppc64el riscv64 s390x
Depends: accountsservice (>= 0.6.35),
         bash (>= 4.3),
         dconf-cli (>= 0.20),
         dconf-gsettings-backend (>= 0.20),
         dbus-bin | systemd-sysv,
         default-dbus-system-bus | dbus-system-bus,
         default-logind [linux-any] | logind [linux-any],
         gir1.2-gdm-1.0 (= ${binary:Version}),
         ubuntu-session | gnome-session | x-session-manager | x-window-manager | x-terminal-emulator,
         gnome-session-bin (>= 50~alpha),
         gnome-session-common (>= 50~alpha),
         gnome-settings-daemon (>= 3.37.0),
         gnome-shell (>= 50~alpha),
         gsettings-desktop-schemas,
         libgdm1 (= ${binary:Version}),
         libglib2.0-bin (>= 2.35.0),
         libnss-systemd,
         libpam-modules (>= 0.72-1),
         libpam-runtime (>= 0.76-13.1),
         librsvg2-common,
         polkitd [linux-any],
         procps,
         ucf,
         x11-common (>= 1:7.6+11),
         x11-xserver-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: at-spi2-core,
            ubuntu-session | gnome-session | x-session-manager,
            x11-xkb-utils,
            zenity
Suggests: orca,
          libpam-fprintd (>= 0.8.0-2),
          libpam-sss (>= 2.3.0-1),
          libpam-pkcs11,
          libpam-gnome-keyring
Provides: x-display-manager
Description: GNOME Display Manager
 GDM provides the equivalent of a "login:" prompt for X displays: it
 asks for a login and starts graphical sessions.
 .
 It supports multiple seats and switching between multiple users.
 .
 The greeter is based on the GNOME libraries and applications, and its
 look and design are the same as those of a GNOME session.

Package: libgdm1
Section: libs
Architecture: linux-any
Depends: ${gir:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: GNOME Display Manager (shared library)
 GDM provides the equivalent of a "login:" prompt for X displays: it
 asks for a login and starts graphical sessions.
 .
 It supports multiple seats and switching between multiple users.
 .
 The greeter is based on the GNOME libraries and applications, and its
 look and design are the same as those of a GNOME session.
 .
 This package contains the shared library required by gnome-shell.

Package: libgdm-dev
Section: libdevel
Architecture: linux-any
Depends: gir1.2-gdm-1.0 (= ${binary:Version}),
         libgdm1 (= ${binary:Version}),
         libglib2.0-dev (>= 2.44.0),
         ${gir:Depends},
         ${misc:Depends}
Provides: ${gir:Provides}
Description: GNOME Display Manager (development files)
 GDM provides the equivalent of a "login:" prompt for X displays: it
 asks for a login and starts graphical sessions.
 .
 It supports multiple seats and switching between multiple users.
 .
 The greeter is based on the GNOME libraries and applications, and its
 look and design are the same as those of a GNOME session.
 .
 This package contains header and development files.

Package: gir1.2-gdm-1.0
Section: introspection
Architecture: linux-any
Depends: ${gir:Depends},
         ${misc:Depends}
Description: GObject introspection data for the GNOME Display Manager
 GDM provides the equivalent of a "login:" prompt for X displays: it
 asks for a login and starts graphical sessions.
 .
 It supports multiple seats and switching between multiple users.
 .
 The greeter is based on the GNOME libraries and applications, and its
 look and design are the same as those of a GNOME session.
 .
 This package contains introspection data for the GNOME Display Manager.

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,6 @@
 built_binaries := $(shell dh_listpackages)
 
 export systemdsystemunitdir = $(shell pkgconf --variable=systemdsystemunitdir systemd | sed s,^/,,)
-export udevdir = $(shell pkgconf --variable=udevdir udev | sed s,^/,,)
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,defs

## gdm3 50~rc

=== debian/changelog ===
gdm3 (50~rc-0ubuntu1) resolute; urgency=medium

  [ Alessandro Astone ]
  * New upstream release
  * d/p/u: Refresh patches
  * d/p: Update EXTRA_DEVICE_ACCESS patch as proposed upstream
  * d/control: Breaks gnome-remote-desktop

  [ Jonas Jelten ]
  * d/t/sssd-gdm-smartcard-pam-auth-tester: allow sssd to run as non-root
    (LP: #2130705)

 -- Alessandro Astone <alessandro.astone@canonical.com>  Wed, 04 Mar 2026 12:59:54 +0100

=== debian/control ===
--- 
+++ 
@@ -86,6 +86,7 @@
           libpam-pkcs11,
           libpam-gnome-keyring
 Provides: x-display-manager
+Breaks: gnome-remote-desktop (<< 50~rc)
 Description: GNOME Display Manager
  GDM provides the equivalent of a "login:" prompt for X displays: it
  asks for a login and starts graphical sessions.
